// structures

struct iMatrix{
	int rows, cols;
	int **x;
};



// functions

iMatrix *imat_alloc(int rows, int cols); 	// allocates memory for a matrix
int imat_read(iMatrix *M);			// reads in a whitespace and newline separated matrix
void  imat_write(iMatrix *M);		//writes out a matrix 
int  imat_max(iMatrix *M);			//prints out row and col index of first occurrence of max value
int  imat_transpose(iMatrix *M);		// matrix transposition
void  imat_ident(iMatrix *M);					// store identity matrix in mat
void  imat_add(iMatrix *a, iMatrix *b, iMatrix *out);		// matrix addition
void  imat_sub(iMatrix *a, iMatrix *b, iMatrix *out);		// matrix subtraction
void  imat_mult(iMatrix *a, iMatrix *b, iMatrix *out);	// matrix multiplication
