//structures
struct iVector{
	int len;
	int *x;
};

//functions

iVector * ivec_alloc(int len);		// allocates memory for an int vector
int  ivec_read(iVector *V);		// read whitespace-delimited vector
int ivec_neighborpair(iVector *V, iMatrix *M);		// matrix predecessor/successor combinations
void  ivec_write(iVector *V);		// write out a vector
int  ivec_max(iVector *V);			//prints out col index of first occurrence of max value
int  ivec_scalar_prod(iVector *v1,iVector *v2);			// SUM[ v1i*v2i ]
