/*
libmatrix.h

matrix manipulation library
version 0.04
Peter A. Cejchan, GPL
Thu Mar 25 13:13:11 EST 2004 <cej@gli.cas.cz | pac7@post.cz | pac@plan9.cz>



*/




//#pragma lib "libmatrix.a"

#define MAXROWS 65536
#define MAXCOLS MAXROWS
#define MAXLENGTH MAXROWS
#define MAXFLOAT 1e20
#define MAXINT 65535

typedef struct Matrix Matrix;
typedef struct iMatrix iMatrix;
typedef struct cMatrix cMatrix;
typedef struct Vector Vector;
typedef struct iVector iVector;
typedef struct Couple Couple;


struct Couple{
	int pred, succ;
};

